import create from 'dd-store';
import pageStore from '../meetingDetail/store';
import { debounce } from '../../utils/utils';
import { checkFullScren } from "../../utils/checkFullScren";
import { updateMeetingTask } from '../../api/request';

create.Page({
  store: pageStore,
  data: {
    currentTask: {},
    show: false,
    isIPX: false,
    limitClick: false
  },
  onLoad(query) {
    this.setData({
      meetingId: query.meetingId,
      isIPX: checkFullScren()
    })
  },
  inputChange: debounce(function (e) {
    const value = e.detail.value;
    this.store.data.currentTask.title = value;
    this.update();
  }, 100),
  handleExcutorChange(e) {
    //执行人页面删除执行人
    if (e.target.dataset.excutorId) {
      dd.navigateTo({ url: `/pages/excutorList/excutorList` })
    }
    //参会人列表页面选择参会人
    else {
      dd.navigateTo({ url: `/pages/attendeeList/attendeeList` })
    }
  },
  handleOpenTime() {
    this.setData({
      show: true
    })
  },
  closePopup() {
    this.setData({
      show: false
    })
  },
  onComplete(event) {
    this.store.data.currentTask.startTime = `${event.startTime}:00`;
    this.store.data.currentTask.endTime = `${event.endTime}:00`;
    this.update();
    this.closePopup();
  },
  addTask() {
    if (this.data.limitClick) {
      return
    }
    this.setData({ limitClick: true });
    const task = this.store.data.currentTask;
    updateMeetingTask({
      meetingId: this.data.meetingId,
      platform: 'dingTalk',
      taskCreateModel: {
        endTime: task.endTime ? task.endTime.replace(/\//g, '-') : '',
        title: task.title,
        innerTaskExecutorList: task.excutorId ? [task.excutor] : null
      }
    }).then(res => {
      if (res.data.code == 0) {
        //重置
        this.store.data.currentTask = {};
        this.update();

        // 修改动态列表
        this.store.data.affairList.unshift({
          "readFlag": 1,
          "commentType": "task",
          "creator": {
            "identify": "xiexiaoqin@mingwork.club",
            "name": "xiaoqin xie",
            "avatar": "https://lh4.googleusercontent.com/-dTkgbJpeQjc/AAAAAAAAAAI/AAAAAAAAAAA/AMZuuckZAY9cef_56Gw_ZglfiXjMmP8pQw/photo.jpg",
            "email": "xiexiaoqin@mingwork.club",
            "platform": "google",
            "userId": "1296022611180703745",
            "orgId": null
          },
          "fileDetailList": null,
          "meetingTaskSimpleViewModel": {
            "title": "测试不要当真",
            "processState": "undetermined",
            "executor": [],
            "taskId": "e9ec94ea7b7665551f295188fbf01409",
            "createTime": "2020-09-27 16:40:09",
            "startTime": null,
            "endTime": null
          },
          "commentCategory": "task_create",
          "remark": null,
          "notes": null,
          "replyCommentList": null,
          "actionLog": null,
          "commentId": "1c41d0c3ca611a79e82a124e04f31928",
          "createTime": "2020-09-27 15:40:09",
          "updateTime": "2020-09-27 15:40:09",
          "parentId": "-1"
        })
        dd.navigateBack();
      }
      this.setData({ limitClick: false });
    })
  }
});
